function $AdfGeckoAgent$$($version$$25$$, $domWindow$$27$$) {
  arguments.length && this.Init($version$$25$$, $domWindow$$27$$);
}
$goog$exportSymbol$$("AdfGeckoAgent", $AdfGeckoAgent$$);
$AdfObject$$.$createSubclass$($AdfGeckoAgent$$, $AdfAgent$$);
$AdfGeckoAgent$$.$InitClass$ = function $$AdfGeckoAgent$$$$InitClass$$() {
  $AdfGeckoAgent$$.$_NBSP_STRING$ = String.fromCharCode(160);
};
$goog$exportSymbol$$("AdfGeckoAgent.InitClass", $AdfGeckoAgent$$.$InitClass$);
$AdfGeckoAgent$$.$__getAgentVersion$ = function $$AdfGeckoAgent$$$$__getAgentVersion$$($userAgent$$8$$) {
  return $AdfAgent$$.$__parseFloatVersion$($userAgent$$8$$, /rv:(\d+[.]\d+)/);
};
$AdfGeckoAgent$$.$__getSupported$ = function $$AdfGeckoAgent$$$$__getSupported$$($userAgent$$9$$, $version$$26$$) {
  return -1 == $userAgent$$9$$.indexOf("Firefox/") ? !1 : 0 == $AdfAgent$$.$_MIN_FIREFOX_VERSION$ ? !0 : $version$$26$$ >= $AdfAgent$$.$_MIN_FIREFOX_VERSION$;
};
$AdfGeckoAgent$$.$__getSpecificAgentClassName$ = function $$AdfGeckoAgent$$$$__getSpecificAgentClassName$$($userAgent$$10$$, $version$$27$$) {
  return 6 <= $version$$27$$ ? "AdfGeckoAgent" : 5 <= $version$$27$$ ? "AdfGecko5Agent" : 1.9 <= $version$$27$$ ? "AdfGecko19Agent" : 1.8 <= $version$$27$$ ? "AdfGecko18Agent" : 1 <= $version$$27$$ ? "AdfGecko17Agent" : "AdfGeckoAgent";
};
$AdfGeckoAgent$$.prototype.Init = function $$AdfGeckoAgent$$$$Init$($version$$28$$, $domWindow$$28$$) {
  $AdfGeckoAgent$$.$superclass$.Init.call(this, $AdfAgent$$.$GECKO_PLATFORM$, $AdfAgent$$.$guessOS$(), $version$$28$$, $domWindow$$28$$);
  this.$_ID_TO_DOM_MAP$ = {};
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.Init", {Init:$AdfGeckoAgent$$.prototype.Init});
$AdfGeckoAgent$$.prototype.getElementById = function $$AdfGeckoAgent$$$$getElementById$($id$$210$$) {
  if (null == $id$$210$$) {
    return null;
  }
  if ($AdfAssert$$.$DEBUG$) {
    var $cachedDom$$ = this.$_ID_TO_DOM_MAP$[$id$$210$$], $elementById$$ = this.$getDomDocument$().getElementById($id$$210$$);
    $cachedDom$$ != $elementById$$ && $AdfAssert$$.assert(!1, "document.getElementById('" + $id$$210$$ + "')\x3d\x3d" + $elementById$$ + " not " + $cachedDom$$);
  }
  return this.$_ID_TO_DOM_MAP$[$id$$210$$];
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.getElementById", {getElementById:$AdfGeckoAgent$$.prototype.getElementById});
$AdfGeckoAgent$$.prototype.$elementsRemoved$ = function $$AdfGeckoAgent$$$$$elementsRemoved$$($idNodes$$1_node$$24$$) {
  var $idToDomMap$$ = this.$_ID_TO_DOM_MAP$, $currId$$1_currNode$$1_targetId$$ = $idNodes$$1_node$$24$$.id;
  null != $currId$$1_currNode$$1_targetId$$ && delete $idToDomMap$$[$currId$$1_currNode$$1_targetId$$];
  if ($idNodes$$1_node$$24$$.firstChild) {
    for ($idNodes$$1_node$$24$$ = this.$getDomDocument$().evaluate(".//*[@id]", $idNodes$$1_node$$24$$, null, XPathResult.ANY_TYPE, null), $currId$$1_currNode$$1_targetId$$ = $idNodes$$1_node$$24$$.iterateNext();$currId$$1_currNode$$1_targetId$$;) {
      ($currId$$1_currNode$$1_targetId$$ = $currId$$1_currNode$$1_targetId$$.getAttribute("id")) && delete $idToDomMap$$[$currId$$1_currNode$$1_targetId$$], $currId$$1_currNode$$1_targetId$$ = $idNodes$$1_node$$24$$.iterateNext();
    }
  }
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.elementsRemoved", {$elementsRemoved$:$AdfGeckoAgent$$.prototype.$elementsRemoved$});
$AdfGeckoAgent$$.prototype.$allElementsRemoved$ = function $$AdfGeckoAgent$$$$$allElementsRemoved$$() {
  this.$_ID_TO_DOM_MAP$ = {};
  this.$elementsAdded$(this.$getDomDocument$());
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.allElementsRemoved", {$allElementsRemoved$:$AdfGeckoAgent$$.prototype.$allElementsRemoved$});
$AdfGeckoAgent$$.prototype.$elementsAdded$ = function $$AdfGeckoAgent$$$$$elementsAdded$$($idNodes$$2_node$$25$$) {
  var $idToDomMap$$1$$ = this.$_ID_TO_DOM_MAP$, $currNode$$2_targetId$$1$$ = $idNodes$$2_node$$25$$.id;
  null != $currNode$$2_targetId$$1$$ && ($idToDomMap$$1$$[$currNode$$2_targetId$$1$$] = $idNodes$$2_node$$25$$);
  if ($idNodes$$2_node$$25$$.firstChild) {
    for ($idNodes$$2_node$$25$$ = this.$getDomDocument$().evaluate(".//*[@id]", $idNodes$$2_node$$25$$, null, XPathResult.ANY_TYPE, null), $currNode$$2_targetId$$1$$ = $idNodes$$2_node$$25$$.iterateNext();$currNode$$2_targetId$$1$$;) {
      var $currId$$2$$ = $currNode$$2_targetId$$1$$.getAttribute("id");
      $currId$$2$$ && ($idToDomMap$$1$$[$currId$$2$$] = $currNode$$2_targetId$$1$$);
      $currNode$$2_targetId$$1$$ = $idNodes$$2_node$$25$$.iterateNext();
    }
  }
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.elementsAdded", {$elementsAdded$:$AdfGeckoAgent$$.prototype.$elementsAdded$});
$AdfGeckoAgent$$.prototype.$setButtonTextContent$ = function $$AdfGeckoAgent$$$$$setButtonTextContent$$($node$$26$$, $newText$$4$$) {
  $AdfAssert$$.$assertDomNode$($node$$26$$);
  if (null === $newText$$4$$ || 0 == $newText$$4$$.length) {
    $newText$$4$$ = $AdfGeckoAgent$$.$_NBSP_STRING$;
  }
  $node$$26$$.textContent = $newText$$4$$;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.setButtonTextContent", {$setButtonTextContent$:$AdfGeckoAgent$$.prototype.$setButtonTextContent$});
$AdfGeckoAgent$$.prototype.$disableUserSelect$ = function $$AdfGeckoAgent$$$$$disableUserSelect$$($element$$73$$) {
  $element$$73$$.style.MozUserSelect = "none";
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.disableUserSelect", {$disableUserSelect$:$AdfGeckoAgent$$.prototype.$disableUserSelect$});
$AdfGeckoAgent$$.prototype.$enableUserSelect$ = function $$AdfGeckoAgent$$$$$enableUserSelect$$($element$$74$$) {
  $element$$74$$.style.MozUserSelect = "";
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.enableUserSelect", {$enableUserSelect$:$AdfGeckoAgent$$.prototype.$enableUserSelect$});
$AdfGeckoAgent$$.prototype.$CreateUIInputEvent$ = function $$AdfGeckoAgent$$$$$CreateUIInputEvent$$($component$$198$$, $type$$122$$, $nativeEvent$$6$$) {
  return "click" == $nativeEvent$$6$$.type && 2 == $nativeEvent$$6$$.button ? null : new $AdfGeckoUIInputEvent$$($component$$198$$, $type$$122$$, $nativeEvent$$6$$);
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.CreateUIInputEvent", {$CreateUIInputEvent$:$AdfGeckoAgent$$.prototype.$CreateUIInputEvent$});
$AdfGeckoAgent$$.prototype.$CreateDefaultLogWriter$ = function $$AdfGeckoAgent$$$$$CreateDefaultLogWriter$$($nativeLogWriter$$2$$) {
  var $domWindow$$30$$ = this.$getDomWindow$();
  return $domWindow$$30$$.console && $domWindow$$30$$.console.firebug ? new $AdfFireBugLogWriter$$($domWindow$$30$$, $nativeLogWriter$$2$$) : $AdfGeckoAgent$$.$superclass$.$CreateDefaultLogWriter$.call(this, $nativeLogWriter$$2$$);
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.CreateDefaultLogWriter", {$CreateDefaultLogWriter$:$AdfGeckoAgent$$.prototype.$CreateDefaultLogWriter$});
$AdfGeckoAgent$$.prototype.$CreateNativeLogWriter$ = function $$AdfGeckoAgent$$$$$CreateNativeLogWriter$$() {
  return new $AdfGeckoLogWriter$$;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.CreateNativeLogWriter", {$CreateNativeLogWriter$:$AdfGeckoAgent$$.prototype.$CreateNativeLogWriter$});
$AdfGeckoAgent$$.prototype.$getNodeType$ = function $$AdfGeckoAgent$$$$$getNodeType$$($element$$75$$) {
  if ($element$$75$$) {
    try {
      return $element$$75$$.nodeType;
    } catch ($e$$44$$) {
    }
  }
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.getNodeType", {$getNodeType$:$AdfGeckoAgent$$.prototype.$getNodeType$});
$AdfGeckoAgent$$.prototype.$getWindowClientWidth$ = function $$AdfGeckoAgent$$$$$getWindowClientWidth$$($domWindow$$31$$) {
  return $domWindow$$31$$.innerWidth;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.getWindowClientWidth", {$getWindowClientWidth$:$AdfGeckoAgent$$.prototype.$getWindowClientWidth$});
$AdfGeckoAgent$$.prototype.$getWindowClientHeight$ = function $$AdfGeckoAgent$$$$$getWindowClientHeight$$($domWindow$$32$$) {
  return $domWindow$$32$$.innerHeight;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.getWindowClientHeight", {$getWindowClientHeight$:$AdfGeckoAgent$$.prototype.$getWindowClientHeight$});
$AdfGeckoAgent$$.prototype.$pointInElementOrChildBounds$ = function $$AdfGeckoAgent$$$$$pointInElementOrChildBounds$$($element$$76_node$$27$$, $pageX$$15$$, $pageY$$15$$) {
  if (this.$pointInElementBounds$($element$$76_node$$27$$, $pageX$$15$$, $pageY$$15$$)) {
    return !0;
  }
  if (!$element$$76_node$$27$$.clientHeight && !$element$$76_node$$27$$.clientWidth) {
    for (var $parent$$8$$ = $element$$76_node$$27$$.parentNode;$parent$$8$$;$parent$$8$$ = $parent$$8$$.parentNode) {
      if ($parent$$8$$.clientWidth || $parent$$8$$.clientHeight) {
        if (this.$pointInElementBounds$($parent$$8$$, $pageX$$15$$, $pageY$$15$$)) {
          break;
        }
        return !1;
      }
    }
    for ($element$$76_node$$27$$ = $element$$76_node$$27$$.firstChild;$element$$76_node$$27$$;$element$$76_node$$27$$ = $element$$76_node$$27$$.nextSibling) {
      if (1 == $element$$76_node$$27$$.nodeType && "absolute" != $element$$76_node$$27$$.style.position && this.$pointInElementOrChildBounds$($element$$76_node$$27$$, $pageX$$15$$, $pageY$$15$$)) {
        return !0;
      }
    }
  }
  return !1;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.pointInElementOrChildBounds", {$pointInElementOrChildBounds$:$AdfGeckoAgent$$.prototype.$pointInElementOrChildBounds$});
$AdfGeckoAgent$$.prototype.$isChromeEvent$ = function $$AdfGeckoAgent$$$$$isChromeEvent$$($domEvent$$5$$) {
  try {
    return $domEvent$$5$$.originalTarget.localName, !1;
  } catch ($e$$45$$) {
    return !0;
  }
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.isChromeEvent", {$isChromeEvent$:$AdfGeckoAgent$$.prototype.$isChromeEvent$});
$AdfGeckoAgent$$.prototype.$setImageSource$ = function $$AdfGeckoAgent$$$$$setImageSource$$($img$$4$$, $src$$6$$) {
  $img$$4$$.setAttribute("src", $src$$6$$);
  this.$_needsReset$ = !0;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.setImageSource", {$setImageSource$:$AdfGeckoAgent$$.prototype.$setImageSource$});
$AdfGeckoAgent$$.prototype.$setImageTooltip$ = function $$AdfGeckoAgent$$$$$setImageTooltip$$($img$$5$$, $tooltip$$1$$) {
  $img$$5$$.title = $tooltip$$1$$;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.setImageTooltip", {$setImageTooltip$:$AdfGeckoAgent$$.prototype.$setImageTooltip$});
$AdfGeckoAgent$$.prototype.$addEventBubbles$ = function $$AdfGeckoAgent$$$$$addEventBubbles$$($node$$28$$, $listener$$68$$) {
  $AdfGeckoAgent$$.$superclass$.$addEventBubbles$.call(this, $node$$28$$, $listener$$68$$);
  $AdfGeckoAgent$$.$superclass$.$addEventBubbles$.call(this, $node$$28$$, $AdfGeckoAgent$$.$_resetThrobber$);
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.addEventBubbles", {$addEventBubbles$:$AdfGeckoAgent$$.prototype.$addEventBubbles$});
$AdfGeckoAgent$$.prototype.$removeEventBubbles$ = function $$AdfGeckoAgent$$$$$removeEventBubbles$$($node$$29$$, $listener$$69$$) {
  $AdfGeckoAgent$$.$superclass$.$addEventBubbles$.call(this, $node$$29$$, $listener$$69$$);
  $AdfGeckoAgent$$.$superclass$.$removeEventBubbles$.call(this, $node$$29$$, $AdfGeckoAgent$$.$_resetThrobber$);
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.removeEventBubbles", {$removeEventBubbles$:$AdfGeckoAgent$$.prototype.$removeEventBubbles$});
$AdfGeckoAgent$$.prototype.$addKeyEventListener$ = function $$AdfGeckoAgent$$$$$addKeyEventListener$$($node$$30$$, $listener$$70$$) {
  $AdfAssert$$.$assertDomNode$($node$$30$$);
  $AdfAssert$$.$assertFunction$($listener$$70$$);
  $node$$30$$.addEventListener("keypress", $listener$$70$$, !1);
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.addKeyEventListener", {$addKeyEventListener$:$AdfGeckoAgent$$.prototype.$addKeyEventListener$});
$AdfGeckoAgent$$.prototype.$removeKeyEventListener$ = function $$AdfGeckoAgent$$$$$removeKeyEventListener$$($node$$31$$, $listener$$71$$) {
  $AdfAssert$$.$assertDomNode$($node$$31$$);
  $AdfAssert$$.$assertFunction$($listener$$71$$);
  $node$$31$$.removeEventListener("keypress", $listener$$71$$, !1);
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.removeKeyEventListener", {$removeKeyEventListener$:$AdfGeckoAgent$$.prototype.$removeKeyEventListener$});
$AdfGeckoAgent$$.$_resetThrobber$ = function $$AdfGeckoAgent$$$$_resetThrobber$$() {
  var $gecko_ownerDocument$$11$$ = $AdfAgent$$.$AGENT$;
  if ($gecko_ownerDocument$$11$$.$_needsReset$) {
    $gecko_ownerDocument$$11$$.$_needsReset$ = !1;
    var $gecko_ownerDocument$$11$$ = $gecko_ownerDocument$$11$$.$getDomDocument$(), $element$$77$$ = $gecko_ownerDocument$$11$$.documentElement, $frame$$ = $gecko_ownerDocument$$11$$.createElement("iframe");
    $frame$$.frameBorder = "0";
    $frame$$.scrolling = "no";
    $frame$$.style.zIndex = 900;
    $frame$$.style.position = "absolute";
    $frame$$.style.borderStyle = "none";
    $frame$$.style.top = $element$$77$$.style.top;
    $frame$$.style.left = $element$$77$$.style.left;
    $frame$$.style.width = $element$$77$$.offsetWidth + "px";
    $frame$$.style.height = $element$$77$$.offsetHeight + "px";
    $gecko_ownerDocument$$11$$.body.appendChild($frame$$);
    $gecko_ownerDocument$$11$$.body.removeChild($frame$$);
  }
};
$AdfGeckoAgent$$.prototype.$showBusyCursor$ = function $$AdfGeckoAgent$$$$$showBusyCursor$$($ownerDocument$$12$$, $show$$2$$) {
  $AdfGeckoAgent$$.$superclass$.$showBusyCursor$($ownerDocument$$12$$, $show$$2$$);
  this.$forceCursorChange$($ownerDocument$$12$$);
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.showBusyCursor", {$showBusyCursor$:$AdfGeckoAgent$$.prototype.$showBusyCursor$});
$AdfGeckoAgent$$.prototype.$isLeftButtonClick$ = function $$AdfGeckoAgent$$$$$isLeftButtonClick$$($evt$$33$$) {
  return "click" == $evt$$33$$.type && 0 == $evt$$33$$.button;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.isLeftButtonClick", {$isLeftButtonClick$:$AdfGeckoAgent$$.prototype.$isLeftButtonClick$});
$AdfGeckoAgent$$.prototype.$isFunctionKey$ = function $$AdfGeckoAgent$$$$$isFunctionKey$$($keyEvent$$2$$) {
  return 0 == $keyEvent$$2$$.which;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.isFunctionKey", {$isFunctionKey$:$AdfGeckoAgent$$.prototype.$isFunctionKey$});
$AdfGeckoAgent$$.prototype.$getKeyCode$ = function $$AdfGeckoAgent$$$$$getKeyCode$$($code$$1_keyEvent$$3$$) {
  if (this.$isFunctionKey$($code$$1_keyEvent$$3$$)) {
    return $code$$1_keyEvent$$3$$.keyCode;
  }
  $code$$1_keyEvent$$3$$ = $code$$1_keyEvent$$3$$.which;
  return 97 <= $code$$1_keyEvent$$3$$ && 122 >= $code$$1_keyEvent$$3$$ ? $code$$1_keyEvent$$3$$ - 32 : $code$$1_keyEvent$$3$$;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.getKeyCode", {$getKeyCode$:$AdfGeckoAgent$$.prototype.$getKeyCode$});
$AdfGeckoAgent$$.prototype.$isElementHTML$ = function $$AdfGeckoAgent$$$$$isElementHTML$$($element$$78$$) {
  $AdfAssert$$.$assertDomNode$($element$$78$$);
  return $element$$78$$ instanceof HTMLElement;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.isElementHTML", {$isElementHTML$:$AdfGeckoAgent$$.prototype.$isElementHTML$});
$AdfGeckoAgent$$.prototype.$removeIdsFromDomSubTree$ = function $$AdfGeckoAgent$$$$$removeIdsFromDomSubTree$$($idNodes$$3_subTreeRoot$$2$$) {
  var $currNode$$3_id$$211$$ = $idNodes$$3_subTreeRoot$$2$$.id;
  null != $currNode$$3_id$$211$$ && "" != $currNode$$3_id$$211$$ && ($idNodes$$3_subTreeRoot$$2$$.id = "");
  if ($idNodes$$3_subTreeRoot$$2$$.firstChild) {
    for ($idNodes$$3_subTreeRoot$$2$$ = this.$getDomDocument$().evaluate(".//*[@id]", $idNodes$$3_subTreeRoot$$2$$, null, XPathResult.ANY_TYPE, null), $currNode$$3_id$$211$$ = $idNodes$$3_subTreeRoot$$2$$.iterateNext();$currNode$$3_id$$211$$;) {
      var $currId$$3$$ = $currNode$$3_id$$211$$.id;
      null != $currId$$3$$ && "" != $currId$$3$$ && ($currNode$$3_id$$211$$.id = "");
      $currNode$$3_id$$211$$ = $idNodes$$3_subTreeRoot$$2$$.iterateNext();
    }
  }
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.removeIdsFromDomSubTree", {$removeIdsFromDomSubTree$:$AdfGeckoAgent$$.prototype.$removeIdsFromDomSubTree$});
$AdfGeckoAgent$$.prototype.$GetCssToDomPropertyNameMap$ = function $$AdfGeckoAgent$$$$$GetCssToDomPropertyNameMap$$() {
  return $AdfGeckoAgent$$.$_CSS_TO_DOM_MAP$;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.GetCssToDomPropertyNameMap", {$GetCssToDomPropertyNameMap$:$AdfGeckoAgent$$.prototype.$GetCssToDomPropertyNameMap$});
$AdfGeckoAgent$$.prototype.$getBoxSizing$ = function $$AdfGeckoAgent$$$$$getBoxSizing$$($element$$79$$, $currentStyle$$9$$) {
  $currentStyle$$9$$ || ($currentStyle$$9$$ = this.getComputedStyle($element$$79$$));
  return $currentStyle$$9$$.getPropertyValue("-moz-box-sizing");
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.getBoxSizing", {$getBoxSizing$:$AdfGeckoAgent$$.prototype.$getBoxSizing$});
$AdfGeckoAgent$$.$_CSS_TO_DOM_MAP$ = {"float":"cssFloat"};
$AdfGeckoAgent$$.$_MOZ_USER_DEFINED$ = "_moz-userdefined";
$AdfGeckoAgent$$.$_FAKE_MOUSEMOVE_EVENT$ = void 0;
$AdfGeckoAgent$$.$_getBoxObjectFor$ = function $$AdfGeckoAgent$$$$_getBoxObjectFor$$($boundingRect$$7_elem$$3$$) {
  var $doc$$18$$ = $boundingRect$$7_elem$$3$$.ownerDocument;
  if ($doc$$18$$.getBoxObjectFor) {
    return $doc$$18$$.getBoxObjectFor($boundingRect$$7_elem$$3$$);
  }
  $boundingRect$$7_elem$$3$$ = $boundingRect$$7_elem$$3$$.getBoundingClientRect();
  return {x:Math.round($boundingRect$$7_elem$$3$$.left), y:Math.round($boundingRect$$7_elem$$3$$.top), width:Math.round($boundingRect$$7_elem$$3$$.width), height:Math.round($boundingRect$$7_elem$$3$$.height)};
};
$AdfGeckoAgent$$.prototype.$atLeast$ = function $$AdfGeckoAgent$$$$$atLeast$$($platform$$3$$, $version$$29$$) {
  if ("number" == typeof $version$$29$$) {
    return $AdfGeckoAgent$$.$superclass$.$atLeast$.call(this, $platform$$3$$, $version$$29$$);
  }
  if ($version$$29$$ && $platform$$3$$ && $platform$$3$$ == this.$getPlatform$()) {
    var $geckoVersionDigits$$ = navigator.userAgent.toLowerCase().match(/rv:(\d+)\.(\d+)\.?(\d+)?\.?(\d+)?/);
    $AdfAssert$$.$assertArray$($geckoVersionDigits$$, "parse gecko version string");
    $geckoVersionDigits$$.splice(0, 1);
    for (var $versionDigits$$ = $version$$29$$.split("."), $maxLen$$ = Math.max($versionDigits$$.length, $geckoVersionDigits$$.length), $i$$72$$ = 0;$i$$72$$ < $maxLen$$;$i$$72$$++) {
      var $geckoDigit$$ = parseInt($geckoVersionDigits$$[$i$$72$$] ? $geckoVersionDigits$$[$i$$72$$] : 0), $versionDigit$$ = parseInt($versionDigits$$[$i$$72$$] ? $versionDigits$$[$i$$72$$] : 0);
      if ($versionDigit$$ != $geckoDigit$$) {
        if ($versionDigit$$ < $geckoDigit$$) {
          break;
        } else {
          return !1;
        }
      }
    }
  } else {
    return !1;
  }
  return !0;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.atLeast", {$atLeast$:$AdfGeckoAgent$$.prototype.$atLeast$});
$AdfGeckoAgent$$.prototype.$pointInElementBounds$ = function $$AdfGeckoAgent$$$$$pointInElementBounds$$($documentElement$$1_element$$80$$, $clientX$$2_pageX$$16$$, $clientY$$2_pageY$$16$$) {
  var $boundingRect$$8$$ = $documentElement$$1_element$$80$$.getBoundingClientRect();
  $documentElement$$1_element$$80$$ = $documentElement$$1_element$$80$$.ownerDocument.documentElement;
  $clientX$$2_pageX$$16$$ -= $documentElement$$1_element$$80$$.scrollLeft;
  $clientY$$2_pageY$$16$$ -= $documentElement$$1_element$$80$$.scrollTop;
  return $clientY$$2_pageY$$16$$ >= $boundingRect$$8$$.top && $clientY$$2_pageY$$16$$ <= $boundingRect$$8$$.bottom && $clientX$$2_pageX$$16$$ >= $boundingRect$$8$$.left && $clientX$$2_pageX$$16$$ <= $boundingRect$$8$$.right;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.pointInElementBounds", {$pointInElementBounds$:$AdfGeckoAgent$$.prototype.$pointInElementBounds$});
$AdfGeckoAgent$$.prototype.slice = function $$AdfGeckoAgent$$$$slice$($file$$2$$, $startByte$$1$$, $stopByte$$1$$) {
  if ("undefined" !== typeof Blob && ("undefined" !== typeof Blob.prototype.slice || "undefined" !== typeof Blob.prototype.mozSlice)) {
    if (null == $file$$2$$) {
      return null;
    }
    if ($file$$2$$.slice) {
      return $file$$2$$.slice($startByte$$1$$, $stopByte$$1$$);
    }
    if ($file$$2$$.mozSlice) {
      return $file$$2$$.mozSlice($startByte$$1$$, $stopByte$$1$$);
    }
  }
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.slice", {slice:$AdfGeckoAgent$$.prototype.slice});
$AdfGeckoAgent$$.prototype.$cloneEvent$ = function $$AdfGeckoAgent$$$$$cloneEvent$$($event$$65$$, $newTarget$$4$$) {
  if (this.$isKeyboardEvent$($event$$65$$)) {
    var $eventType$$18$$ = $event$$65$$.type, $newEvent$$4$$ = this.$_copyKeyboardEvent$($event$$65$$, $eventType$$18$$, $newTarget$$4$$), $targetNode$$4$$ = $newTarget$$4$$ ? $newTarget$$4$$ : $event$$65$$.target, $targetDocument$$3$$ = $targetNode$$4$$.ownerDocument;
    $targetDocument$$3$$.addEventListener($eventType$$18$$, this.stopPropagation, !0);
    try {
      $targetNode$$4$$.dispatchEvent($newEvent$$4$$);
    } finally {
      $targetDocument$$3$$.removeEventListener($eventType$$18$$, this.stopPropagation, !0);
    }
    return $newEvent$$4$$;
  }
  return $AdfGeckoAgent$$.$superclass$.$cloneEvent$.call(this, $event$$65$$, $newTarget$$4$$);
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.cloneEvent", {$cloneEvent$:$AdfGeckoAgent$$.prototype.$cloneEvent$});
$AdfGeckoAgent$$.prototype.$getMaxConnectionsPerDomain$ = function $$AdfGeckoAgent$$$$$getMaxConnectionsPerDomain$$() {
  return 6;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.getMaxConnectionsPerDomain", {$getMaxConnectionsPerDomain$:$AdfGeckoAgent$$.prototype.$getMaxConnectionsPerDomain$});
$AdfGeckoAgent$$.prototype.$_copyKeyboardEvent$ = function $$AdfGeckoAgent$$$$$_copyKeyboardEvent$$($event$$66$$, $eventType$$19$$, $newTarget$$5_targetDocument$$4$$) {
  $newTarget$$5_targetDocument$$4$$ = ($newTarget$$5_targetDocument$$4$$ ? $newTarget$$5_targetDocument$$4$$ : $event$$66$$.target).ownerDocument;
  var $newEvent$$5$$ = $newTarget$$5_targetDocument$$4$$.createEvent("KeyboardEvent");
  $newEvent$$5$$.initKeyEvent($eventType$$19$$, !0, !0, $newTarget$$5_targetDocument$$4$$.contentWindow, $event$$66$$.ctrlKey, $event$$66$$.altKey, $event$$66$$.shiftKey, $event$$66$$.metaKey, $event$$66$$.keyCode, $event$$66$$.charCode);
  return $newEvent$$5$$;
};
$AdfGeckoAgent$$.prototype.$isDragPrepEvent$ = function $$AdfGeckoAgent$$$$$isDragPrepEvent$$($componentEvent$$8_nativeEvent$$7$$) {
  if ($AdfGeckoAgent$$.$superclass$.$isDragPrepEvent$.call(this, $componentEvent$$8_nativeEvent$$7$$)) {
    $componentEvent$$8_nativeEvent$$7$$ = $componentEvent$$8_nativeEvent$$7$$.$getNativeEvent$();
    var $explicitOriginalTarget$$ = $componentEvent$$8_nativeEvent$$7$$.explicitOriginalTarget;
    return $explicitOriginalTarget$$ === $componentEvent$$8_nativeEvent$$7$$.originalTarget ? !0 : 1 != $explicitOriginalTarget$$.nodeType;
  }
  return !1;
};
$AdfObject$$.$exportPrototypeSymbol$("AdfGeckoAgent.prototype.isDragPrepEvent", {$isDragPrepEvent$:$AdfGeckoAgent$$.prototype.$isDragPrepEvent$});
